package es.us.ccia.dummy;

import java.util.ArrayList;
import java.util.Iterator;
//import java.util.LinkedList;
import java.util.StringTokenizer;

import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;

//import jpl.Query;

import es.us.ccia.contexto.Contexto;
import es.us.ccia.contexto.elementos.FCAAttribute;
import es.us.ccia.contexto.elementos.FCAElement;
import es.us.ccia.contexto.elementos.FCAObject;
import es.us.ccia.dummy.contexto.entsal.Importar;
import es.us.ccia.dummy.dibujo.*;
import es.us.ccia.dummy.historial.H_Cambios5;
import es.us.ccia.dummy.historial.ListaCambios;
//import es.us.ccia.dummy.historial.cambios.ListaCambios;
import es.us.ccia.dummy.razonGrafico.RazonG_RCC5;
import es.us.ccia.dummy.razonGrafico.RazonG_RCC8;
import es.us.ccia.dummy.teoria.Teoria;
import es.us.ccia.dummy.teoria.regiones.ListaElementos;
import es.us.ccia.dummy.teoria.relaciones.ListaRelacionRCC;
import es.us.ccia.dummy.teoria.relaciones.Relacion;
import es.us.ccia.razonador.Razonador;
import es.us.ccia.rcc.RCC;
import es.us.tad.*;

@SuppressWarnings({"serial","unchecked"})
public class EntornoGD extends GUI {

	public EntornoGD() {
		super("* DummyPaella *",1); // 1 = DUMMY
	}
 			 
	
	
	
	

	
	public void botonEjecutarCambios(ListaElementos _nuevaconfig) {

		System.out.println("===============================================");
		System.out.println(DummyPaella.getTeoria().getListaRegiones());
		System.out.println(_nuevaconfig);
		System.out.println("===============================================");
		System.out.println("Antigua: " + DummyPaella.getTeoria().getListaRelacionesRCC());
		
		
		ListaRelacionRCC anterior = DummyPaella.getTeoria().getListaRelacionesRCC();
		ListaRelacionRCC nueva;
		if (DummyPaella.Razonamiento == RCC.DummyRCC8) {
			nueva = RazonG_RCC8.Dibujo_a_RCC(_nuevaconfig);
		} else {
			nueva = RazonG_RCC5.Dibujo_a_RCC(_nuevaconfig);
		}
		System.out.println("nueva: " + nueva);
		System.out.println("===============================================");
		System.out.println(" Lista de cambios ... ");
		
		ListaCambios  lc = new ListaCambios();
		Iterator i = nueva.iterator();
		while (i.hasNext()) {
			Relacion r = (Relacion)i.next();
			int tipoviejo = anterior.getTipoRCC(r.getA(), r.getB());
			
			if (tipoviejo != r.getTipo() ) {
				System.out.println("tipo cambiado de " + tipoviejo + " a " + r.getTipo());
				
				
				if (DummyPaella.Razonamiento == RCC.DummyRCC8) {
					
				} else if (DummyPaella.Razonamiento == RCC.DummyRCC5) {
					
					FCAElement ele_a,ele_b;
					
					if (Contexto.isAttribute(r.getA()))
						ele_a = Contexto.getAttribute(r.getA());
					else 
						ele_a = Contexto.getObject(r.getA());

					if (Contexto.isAttribute(r.getB()))
						ele_b = Contexto.getAttribute(r.getB());
					else 
						ele_b = Contexto.getObject(r.getB());
					
					
					
					lc.add(H_Cambios5.getCambio(ele_a, ele_b, tipoviejo, r.getTipo(), null));
					
				}
				
			}
			
			
		}
		
		lc.ejecutar();
		DummyPaella.getGUI().reiniciarContexto();

		System.out.println("===============================================");
		
		
		

	}

	@Override
	public void cambioListaClases(ArrayList _lista) {

		/** 
		 * QUE PASA CUANDO CAMBIO UNA SELECCION DE CLASE!!
		 */
		
		if (_lista.size()>1) {
		Teoria t = DummyPaella.getTeoria();
		t.limpiarClases();
		
		ArrayList<FCAAttribute> listac = new ArrayList<FCAAttribute>();
		Iterator i = _lista.iterator();
		while (i.hasNext()) {
			FCAAttribute att  = Contexto.getAttribute((String)i.next());
			if (att == null) {
				System.out.println("CLASE no encontrada");
			} else {
				listac.add(att);				
			}
		}
		t.insertarClases(listac);

		t.Argumentos_a_RCC();
		
		
		
		t.calcularRegiones();
		
//		System.out.println(t.getListaRelacionesRCC());
		
		pintarRelacionesRCC(t.getListaRelacionesRCC().toList());

//		System.out.println("=====================================");
//		System.out.println(t.getListaRegiones().size());
//		System.out.println("=====================================");
				
		pintarVentanaDibujo(t.getListaRegiones());
				
//		Salida.Imprimirln(t.getListaRelacionesRCC().toString());
//		Salida.Imprimirln(Contexto.imprimir());
		
		} else {			
			pintarRelacionesRCC(new ListaRelacionRCC().toList());
			pintarVentanaDibujo(new ListaElementos());
		}
	}
	
	@Override
	public void cambioListaIndividuos(ArrayList _lista) {

		Teoria t = DummyPaella.getTeoria();
		t.limpiarIndiv();

		ArrayList<FCAObject> listai = new ArrayList<FCAObject>();
		Iterator i = _lista.iterator();
		while (i.hasNext()) {
			FCAObject obj = Contexto.getObject((String)i.next());
			if (obj == null) {
				Salida.Imprimirln("OBJETO no encontrado");
			} else {
				listai.add(obj);
			}
		}
		t.insertarIndividuos(listai);
		
//		System.out.println(t.toString());
		
		
		
		t.Argumentos_a_RCC();
		t.calcularRegiones();
		
		pintarRelacionesRCC(t.getListaRelacionesRCC().toList());

		pintarVentanaDibujo(t.getListaRegiones());
		
		
		
		
//		
//		/**************************************************/
//		/*******  CAmbio de LISTA DE INDIVIDUOS   *********/
//		/**************************************************/
//		if (!DummyPaella.getGUI().getVentanaDibujo().estaModificada()) {
//			
//			actualizarIndividuos();
//				
//		} else {
//				
//			int res = JOptionPane.showConfirmDialog( DummyPaella.getGUI().getVentanaDibujo(),
//					"If you change your selection,you will loose your movements,\n are you SURE?",
//					"Confirmation - Paella.",JOptionPane.YES_NO_OPTION );
//					   
//			if( res == JOptionPane.YES_OPTION ) { 
//				actualizarIndividuos();
//				DummyPaella.getGUI().getVentanaDibujo().setModificado(false);
//			} else {
//				//respuesta = "Si";
//			}
//					    
//			Salida.Imprimirln("Esto no se puede elegir.. el dibujo esta modificado.");
//		}
	}
		
		
	public void cambioListaRelaciones() {
		
		/**************************************************/
		/*******  CAmbio de LISTA DE RELACIONNES   *********/
		/**************************************************/
		
		ListaElementos miteoria = DummyPaella.getTeoria().getListaRegiones();
		
//		if (!(arg0.getValueIsAdjusting())) {
			
			miteoria.desmarcarElementos();
			ArrayList lista = getListaRelaciones();
			Iterator i = lista.iterator();

			while (i.hasNext()) {
				StringTokenizer r = new StringTokenizer(i.next().toString(),"(),");
				r.nextToken();
				miteoria.marcarElemento(r.nextToken());
				miteoria.marcarElemento(r.nextToken());
			}
			repintarDibujo();
//		}

	}
	
	
	  

	
	
	
	
	
	
	
	
	
	

//	private void actualizarClases(ArrayList _lista) {
//
//		// TEORIA
//		Teoria miteoria = DummyPaella.getTeoria();
//
//		// INICIALIZACION
//		miteoria.limpiarClases();
//		miteoria.insertarClases(_lista);
//
//		// LLAMADA AL RAZONADOR
//		miteoria.Argumentos_a_RCC(); 
//		
//		// MINIMIZAR RELACIONES
////		miteoria.simplificarRelacionesRCC8();
//		
//		// CHR - PROLOG
//		miteoria.calcularRegiones();
//		
//		// DESDE EL DIBUJO
//		miteoria.Dibujo_a_RCC8();
////		miteoria.simplificarRelacionesRCC8();
//		
//		// ACTUALIZAR GRAFICOS
//		getVentanaRelaciones().actualizar(null);
//		getVentanaHistorial().limpiar();
//		getAreaDibujo().repaint();
//	
//	}
//	
//	private void actualizarIndividuos(ArrayList _lista) {
//		// TEORIA
//		Teoria miteoria = DummyPaella.getTeoria();
//
//		// INICIALIZACION
//		miteoria.limpiarIndiv();
//		miteoria.insertarIndividuos(_lista);
//			
//		// LLAMADA AL RAZONADOR
//		miteoria.Argumentos_a_RCC(); 
//				
//		// CHR - PROLOG
//		miteoria.calcularRegiones();
//		
//		// DESDE EL DIBUJO
//		miteoria.Dibujo_a_RCC8();
////		miteoria.simplificarRelacionesRCC8();
//		
//		// ACTUALIZAR GRAFICOS
//		getAreaDibujo().repaint();
//		getVentanaRelaciones().actualizar(null);
//		getVentanaHistorial().limpiar();
//
//	}

	@Override
	public void cambioVentanaDibujo(ListaElementos _lista) {
		// TODO Auto-generated method stub
//		System.out.println(_lista.toString());

		

//		
//		teoria.Dibujo_a_RCC8();
//		
//		ListaCambios lc = teoria.getCambiosRelaciones(activo.getArgumento());
//		lc.ejecutar();
//		
////		RazonadorRCC8.reCalcula();
//
//		teoria.Argumentos_a_RCC();
//		teoria.calcularRegiones();
//		teoria.Dibujo_a_RCC8();
//		
//		Salida.Imprimirln(Contexto.imprimir());
//		Salida.Imprimirln("---------------------");
//		Salida.Imprimirln(Razonador.escribirRel());
//		Salida.Imprimirln("---------------------");
//
//		
//		
//		g.getVentanaRelaciones().actualizar();
//		g.getVentanaHistorial().actualizar();
	
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
	}

	public void valueChanged(ListSelectionEvent e) {
		// TODO Auto-generated method stub
		
	}


	public void menuImportarDel() {
		
		Salida.Imprimirln("OPCION DE IMPORTAR");
		Salida.Imprimirln("--Empieza a importar");

		Contexto.inicializar("importado");
		Salida.Imprimirln("--contexto inicializado");
		
		// Sacar la ventana con el tema de usuario y contrasena
		
		String usuario = JOptionPane.showInputDialog(this, "User: ", "titulo", JOptionPane.QUESTION_MESSAGE);
		String contra  = JOptionPane.showInputDialog(this, "Password", "titulo", JOptionPane.QUESTION_MESSAGE);
		
		Importar imp = new Importar(usuario,contra);
//			Importar imp = new Importar("jaalonso","Wu_Wei_08");
		imp.importar();

//		Razonador.inicializar(Razonador.RCC5);
		Salida.Imprimirln("--FIN de la importacion");
		reiniciarContexto();
		Salida.Imprimirln("--grafico actualizado..");			
//			DummyPaella.getGUI().getAreaDibujo().repaint();
		
		

		Razonador.inicializar(RCC.DummyRCC5,null);
		reiniciarContexto();
		
		
		
	}



	@Override
	public void hacerSugerencias(ArrayList clases) {

		// En esta aplicacion no se hace nada de sugerencias.
		
	}

	
	public void reiniciarContexto(){
	
		DummyPaella.getTeoria().reiniciarTeoria();
		
		getVetiq().reiniciar(Contexto.getAttributes());
		getVindiv().reiniciar(Contexto.getObjects());
		//	  vhist.actualizar();
		getVrel().actualizar(null);
		//	  	vdibujo.repaint();
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
